
program disegno
  implicit none
  interface
    pure function f(xi)
      integer,parameter :: ikind = selected_real_kind(p=16,r=20)
      real(kind=ikind), dimension(2) :: f
      real(kind=ikind), dimension(2), intent(IN) :: xi
      end function f
    end interface
  integer,parameter :: ikind = selected_real_kind(p=16,r=20)
  real(kind=ikind), parameter :: pi=4.*atan(1.)
  real(kind=ikind), parameter :: pi2 =2.*pi
  integer :: i, n, n2
  real(kind=ikind) :: r, time, oldtime, norm
  real(kind=ikind), allocatable, dimension(:,:) :: fvals
  real(kind=ikind), allocatable, dimension(:) :: nodix
  character (len=10) :: arg0, arg1

  call cpu_time( oldtime )

  call getarg(1,arg0)
  call getarg(2,arg1)
  read(arg0,*) r  
  read(arg1,*) n

  n2=2*n
  allocate(fvals(0:n2,2))
  allocate(nodix(0:n2))


  nodix = (/ (pi/float(n)*float(i), i=0,n2)/)
  do i=0,n2 
    fvals(i,:)=f((/ r*cos(nodix(i)) , r*sin(nodix(i)) /))
    norm = sqrt(dot_product(fvals(i,:),fvals(i,:)))
    fvals(i,:) = fvals(i,:)*log10(1.+norm)/norm
    end do

  open(unit=3,file='disegno.dat',form='formatted',status='old')
  do i=0,n2
    write(3,*) fvals(i,:)
    end do 
  close(3)

  call cpu_time( time )
  oldtime= time-oldtime
  print*, "CPU time = ",oldtime
  end program disegno
    